//get max 
float max2D(float[][] array2D) {
  float max = 0;
  for (int i=0; i<array2D.length; i++) {
    for (int j=0; j<array2D[i].length; j++) {
      if (array2D[i][j] > max) {
        max = array2D[i][j];
      }
    }
  }
  return max;
}

// get min 
float min2D(float[][] array2D) {
  float max = max2D(array2D);
  float min = max;
  for (int i=0; i<array2D.length; i++) {
    for (int j=0; j<array2D[i].length; j++) {
      if (array2D[i][j] < min) {
        min = array2D[i][j];
      }
    }
  }
  return min;
}

// normalize
void normalize() {
  for (int i=0; i<numCols-2; i++)
  {
    for (int j=0; j<numRows; j++)
    {
      colorMode(HSB, 255);
      stroke(50);
      strokeWeight(0.2);
      // dataMatrix[i][j] = log(table.getFloat(j, i+2));
      float sat = map((dataMatrix[i][j]), minValue, maxValue, 0, 100);
      // println(sat);
      float bri = map((dataMatrix[i][j]), minValue, maxValue, 0, 100);
      if (i == 0) {
        fill(HSB, #d53e4f, sat, bri);
      } else if (i == 1) {
        fill(HSB, #fc8d59, sat, bri);
      } else if (i == 2) {
        fill(HSB, #fee08b, sat, bri);
      } else if (i == 3) {
        fill(HSB, #e6f598, sat, bri);
      } else if (i == 4) {
        fill(HSB, #99d594, sat, bri);
      } else if (i == 5) {
        fill(HSB, #3288bd, sat, bri);
      } else {
        fill(0, 0, 0);
      }
      pushMatrix();
      // rect(x, y, width, height, radius)
      rect(horMargin+cellWidth*j, verMargin+cellHeight*i+30, cellWidth, cellHeight-10, 1);
      popMatrix();
    }
  }

  maxValue = max2D(dataMatrix);
  minValue = min2D(dataMatrix);
}

// reset
void reset() {
  for (int i=0; i<numCols-2; i++) {
    for (int j=0; j<numRows; j++) {
      dataMatrix[i][j] = table.getFloat(j, i+2);
    }
  }
  maxValue = max2D(dataMatrix);
  minValue = min2D(dataMatrix);
}

// x-ray
float grayscale;
void colorscheme() {
  for (int i=0; i<numCols-2; i++) {
    for (int j=0; j<numRows; j++) {
      stroke(255);
      strokeWeight(0.5);
      grayscale = map(dataMatrix[i][j], maxValue, minValue, 0, 255);
      fill(grayscale);
      rect(horMargin+cellWidth*j, verMargin+cellHeight*i+30, cellWidth, cellHeight-10, 1);
    }
  }
}